(document:surround "/std/frame")
(document:envelop with-translation _ "alterator-install2")

(define all-packages (make-cell '()))

(define (summary x)
  (cons (woo-get-option x 'summary (woo-get-option x 'name)) #f))

(define (name x y)
  (and (cdr x)
       (woo-get-option y 'name)))

(define (load-packages)
  (woo-catch
           (thunk (woo-list "/apt-profile/install3"))
           (lambda(reason)
             (document:popup-critical (_ "unable to read package installation profile") 'ok)
             '())))

(define (write-update)
	(woo-catch/message
		(thunk	(woo-write "/apt-get" 'job "update" 'packages "  ")
			(woo-write "/autoinstall/apt-get" 'job "update" 'packages "  "))))

(hbox
	(spacer)
	(groupbox (_ "Select packages you want to install")
		max-width 300
		max-height 300
		(document:id packages (checklist)))
	(spacer))

(define (install-packages lst)
  (and  (eq? 'ok (document:popup '/apt
                                 'packages lst
                                 'job "install"))
        (woo-write "/autoinstall/apt-get"
	                         'packages (string-join lst " ")
	                         'job "install")))
(frame:on-next (thunk
                (let ((install-list
                       (filter-map name
                                   (packages checklist-rows)
                                   (cell-ref all-packages))))
                  (and (pair? install-list)
		       (or (install-packages install-list) 'cancel)))))

(document:root
	(when loaded
		(write-update)
		(let ((packages-list (load-packages)))
			(cell-set! all-packages packages-list)
			(packages checklist-rows (map summary packages-list)))))
