(document:surround "/std/frame")
(document:insert "/std/functions")
(document:envelop with-translation _ "alterator-install2")

(define countries (woo-catch/message (thunk (woo-list '/tzone/countries))))
(define zoneinfo (woo-catch/message (thunk (woo-list '/tzone/zones))))
(define zone-defaults (woo-catch/message (thunk (car (woo-read '/tzone/zones)))))
(define ntp-servers (woo-catch/message (thunk (woo-read '/tzone/ntps))))
(define country-code (make-cell #f))

(define (write-tzone url)
  (woo-write url
	     "zone" (woo-get-option
		     (or (cond-car (filter (lambda(x) 
					     (if (and (string=? (city-list text) (woo-get-option x 'city ""))
						      (string=? (cell-ref country-code) (woo-get-option x 'code "")))
						 #t #f))
					   zoneinfo))
			 '())
		     'zone)
))
;	     "date"   (date-set text)
;	     "time"   (time-set text)
;	     "utc"    (utc-set state)
;	     "usentp" (use-ntp state)))


(define (write-ntp url)
  (woo-try "new" url
	   "type" "pool" 
	   "name" (if (> (length ntp-servers) (ntp-server current))
		      (woo-get-option (list-ref ntp-servers (ntp-server current)) 'server)
		      (ntp-server text))))

(define (save-all-tabs)
  (woo-catch/message (thunk
;                           (timeedit stop)
			    (write-tzone "/tzone")
			    (write-tzone "/autoinstall/tzone")
)))
;			    (if (woo-get-option zone-defaults 'ntp #f)
;				(and (utc-set state)
;				     (write-ntp "/openntpd")
;				     (write-ntp "/autoinstall/openntpd"))))))

(define (rows->list lst)
  (map (lambda(x) (car (car (vector->list x)))) lst))

(define (show-cities)
  (cell-set! country-code (woo-get-option (list-ref countries (country-list current)) 'code))
  (city-list rows (map (lambda(x) (woo-get-option x 'city))
		       (filter (lambda (x) (string=? (cell-ref country-code) (woo-get-option x 'code ""))) zoneinfo)))
  (and (not (null? (city-list rows)))
       (city-list current (or
			   (string-list-index
			    (woo-get-option zone-defaults 'city "")
			    (rows->list (city-list rows)))
			   0))))
(define (use-ntp-state st)
  (use-ntp state st)
  (ntp-server activity st)
  (date-set activity (not st))
  (time-set activity (not st))
  (utc-set  activity (not st)))

(gridbox columns "20;60;20"
	 (spacer)
	 (tabbox
	  (tab (_ "Time zone")
	       (gridbox columns "30;40;30"
			;; line
			(spacer)
			(vbox (label (_ "Please, select country:"))
			      (document:id country-list
					   (combobox rows (map (lambda(x) (woo-get-option x 'country)) countries)
						     (when selected (show-cities)))))
			(spacer)

			;; line
			(spacer)
			(label " ")
			(spacer)

			;; line
			(spacer)
			(vbox (label (_ "Please, select zone:"))
			      (document:id city-list (listbox rows '())))
			(spacer)
		)
	  )

;	  (tab (_ "Date/Time")
;	       margin 10
;	       (document:id ntp-ui
;			    (hbox visibility #f
;				  (vbox
;				   (document:id use-ntp (checkbox (_ "Set Date/Time automatically:")
;								  state #f
;								  (when toggled (use-ntp-state (use-ntp state)))))
;				   (label " "))
;				  (vbox
;				   (document:id ntp-server 
;						(combobox rows (map (lambda(x) (string-append (woo-get-option x 'area)
;											      " (" (woo-get-option x 'server) ")"))
;								    ntp-servers)
;							  tooltip (_ "Add other server and press 'Enter'")
;							  current 0
;							  activity #f
;							  alterability #t))
;				   (label (_ "<small>Hint: you may add another pool server</small>")))))
;
;	       (vbox (label (_ "Setup current date:"))
;		     (document:id date-set (dateedit expanded #t)))
;
;	       (label " ")
;
;	       (vbox (label (_ "Setup current time:"))
;		     (document:id time-set (timeedit expanded #f))
;		     (document:id utc-set (checkbox (_ "Hardware clock set to GMT")
;						    state (woo-get-option zone-defaults 'utc #f))))
;	  )
	 )

	 (spacer))

(document:root (when loaded
		     (country-list current (or
					    (string-list-index (woo-get-option zone-defaults 'country "")
							       (rows->list (country-list rows)))
					    0))
;		     (ntp-ui visibility (woo-get-option zone-defaults 'ntp #f))
		     (show-cities)))
(frame:on-next (thunk (save-all-tabs)))
